package com.smartgwt.sample.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.i18n.client.NumberFormat;
import com.smartgwt.client.data.Criteria;
import com.smartgwt.client.data.DSCallback;
import com.smartgwt.client.data.DSRequest;
import com.smartgwt.client.data.DSResponse;
import com.smartgwt.client.data.DataSource;  
import com.smartgwt.client.data.RecordList;  
import com.smartgwt.client.types.Alignment;  
import com.smartgwt.client.types.AutoSelectionModel;  
import com.smartgwt.client.types.DragDataAction;
import com.smartgwt.client.types.Overflow;  
import com.smartgwt.client.types.VerticalAlignment;  
import com.smartgwt.client.util.SC;  
import com.smartgwt.client.widgets.Canvas;  
import com.smartgwt.client.widgets.HTMLFlow;  
import com.smartgwt.client.widgets.IButton;
import com.smartgwt.client.widgets.Label;  
import com.smartgwt.client.widgets.cube.CubeGrid;  
import com.smartgwt.client.widgets.cube.Facet;  
import com.smartgwt.client.widgets.cube.FacetValue;  
import com.smartgwt.client.widgets.cube.FacetValueMap;  
import com.smartgwt.client.widgets.cube.events.*;  
import com.smartgwt.client.widgets.events.ClickEvent;
import com.smartgwt.client.widgets.events.ClickHandler;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.SelectItem;
import com.smartgwt.client.widgets.form.fields.events.ChangedEvent;
import com.smartgwt.client.widgets.form.fields.events.ChangedHandler;
import com.smartgwt.client.widgets.grid.CellFormatter;
import com.smartgwt.client.widgets.grid.HoverCustomizer;  
import com.smartgwt.client.widgets.grid.ListGrid;
import com.smartgwt.client.widgets.grid.ListGridField;  
import com.smartgwt.client.widgets.grid.ListGridRecord;  
import com.smartgwt.client.widgets.layout.HLayout;
import com.smartgwt.client.widgets.layout.VLayout;  
import com.smartgwt.client.widgets.menu.MenuButton; 

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class SmartgwtOLAP implements EntryPoint {

	/**
     * This is the entry point method.
     */
	 private NumberFormat nf = NumberFormat.getFormat("#,##0.00");
	 private CubeGrid advancedCube = new CubeGrid();
	 private Label reportLabel;  
	 private FacetList rowFacetList;  
	 private FacetList colFacetList;    
	 private Facet[] facets;
	 private int contFacet = 0;
	 private Canvas controlCanvas = null;
	 private String[][] facetInfo = null;
	 private VLayout rightLayout = new VLayout();
	 private HLayout mainLayout = new HLayout();
	 private VLayout leftLayout = new VLayout();
	 private String rowFacets = "";
	 private String columnFacets = "";

	 public void onModuleLoad() {  
	     Canvas topCanvas = null;  
	     if(SC.hasAnalytics()) {

	         mainLayout = new HLayout();  
	         mainLayout.setWidth100();  
	         mainLayout.setHeight100();  
	         mainLayout.setMembersMargin(8);  
	         mainLayout.setLayoutMargin(10);
 
	         leftLayout = new VLayout();  
	         leftLayout.setWidth(300);  
	         leftLayout.setHeight100();  
	         leftLayout.setMembersMargin(8);  
	         leftLayout.setLayoutMargin(10);
	         
	         rightLayout = new VLayout();  
	         rightLayout.setWidth(500);  
	         rightLayout.setHeight100();  
	         rightLayout.setMembersMargin(8);  
	         rightLayout.setLayoutMargin(10);
	         
	    	 // Label to show current state of CubeGrid facets  
	         reportLabel = new Label();  
	         reportLabel.setWidth(500);  
	         reportLabel.setHeight(30);  
	         reportLabel.setWrap(false);  
	         reportLabel.setOverflow(Overflow.VISIBLE);  
	         reportLabel.setPadding(5);  
	         reportLabel.setBorder("1px solid black");  
	         reportLabel.setStyleName("blackOnWhite");  
	         reportLabel.setAlign(Alignment.CENTER);  
	         reportLabel.setValign(VerticalAlignment.CENTER);  
	         reportLabel.setLayoutAlign(Alignment.CENTER);
	         
	         final DataSource dsCubes = DataSource.get("listCubes");
	         final DataSource dsDimensions = DataSource.get("listDimensions");
	         final DataSource dsMembers = DataSource.get("listMembers");
	         
	         DynamicForm form = new DynamicForm();
	    	 form.setWidth(200);
	    	 form.setHeight(50);
	    	 
	    	 final ListGrid gridDimensions = new ListGrid();
	    	 gridDimensions.setDataSource(dsDimensions);
	    	 gridDimensions.setAutoFetchData(false);
	    	 gridDimensions.setWidth(200);
	    	 gridDimensions.setHeight(200);
	    	 gridDimensions.setCanReorderRecords(true);  
	    	 gridDimensions.setCanDragRecordsOut(true);  
	    	 gridDimensions.setCanAcceptDroppedRecords(true);  
	    	 gridDimensions.setDragDataAction(DragDataAction.MOVE); 
	    	 gridDimensions.setTooltip("The drag and drop function is enabled.");
	    	 
	    	 final ListGrid gridRows = new ListGrid();
	    	 ListGridField recRow = new ListGridField("nameDimension","Rows Dimensions");
	    	 gridRows.setWidth(200);
	    	 gridRows.setHeight(100);
	    	 gridRows.setCanReorderRecords(true);  
	    	 gridRows.setCanDragRecordsOut(true);  
	    	 gridRows.setCanAcceptDroppedRecords(true);  
	    	 gridRows.setDragDataAction(DragDataAction.MOVE);
	    	 gridRows.setFields(recRow);
	    	 gridRows.setPreventDuplicates(true);
	    	 gridRows.setTooltip("The drag and drop function is enabled.");
	    	 
	    	 final ListGrid gridColumns = new ListGrid();
	    	 ListGridField recCol = new ListGridField("nameDimension","Columns Dimensions");
	    	 gridColumns.setWidth(200);
	    	 gridColumns.setHeight(100);
	    	 gridColumns.setCanReorderRecords(true);  
	    	 gridColumns.setCanDragRecordsOut(true);  
	    	 gridColumns.setCanAcceptDroppedRecords(true);  
	    	 gridColumns.setDragDataAction(DragDataAction.MOVE); 
	    	 gridColumns.setFields(recCol);
	    	 gridColumns.setPreventDuplicates(true);
	    	 gridColumns.setTooltip("The drag and drop function is enabled.");
	    	 
	    	 final SelectItem selectCubes = new SelectItem();
	    	 selectCubes.setName("nameCube");
	    	 selectCubes.setDisplayField("nameCube");
	    	 selectCubes.setTitle("Select Cube of Data");
	    	 selectCubes.setOptionDataSource(dsCubes);
	    	 selectCubes.addChangedHandler(new ChangedHandler(){
				@Override
				public void onChanged(ChangedEvent event) {
					Criteria criteria = new Criteria();
					criteria.addCriteria("nameCube", event.getValue().toString());
			    	gridDimensions.fetchData(criteria);
			    	gridRows.setData(new ListGridRecord[0]);
			    	gridColumns.setData(new ListGridRecord[0]);
				}
	    	 });
	    	 IButton buttonCreateCube = new IButton();
	    	 buttonCreateCube.setTitle("Create CubeGrid");
	    	 buttonCreateCube.setWidth(150);
	    	 buttonCreateCube.addClickHandler(new ClickHandler(){
				@Override
				public void onClick(ClickEvent event) {
					if (gridColumns.getRecords().length == 0) {
						SC.warn("You must select at least one Column");
						return;
					}
					if (gridRows.getRecords().length == 0) {
						SC.warn("You must select at least one Row");
						return;
					}
					final ListGridRecord recColumns[] = gridColumns.getRecords();
					final ListGridRecord recRows[] = gridRows.getRecords();
					facets = new Facet[recColumns.length+recRows.length+1];// add an extra dimension to the scenarios
					rowFacets = "";
					columnFacets = "";
					final String[] columns = new String[recColumns.length];
					// getting the columns facets
					for (int i = 0; i< recColumns.length; i++) {
						columnFacets = columnFacets+recColumns[i].getAttributeAsString("nameDimension")+",";
						columns[i] = recColumns[i].getAttributeAsString("idDimension");
					}
					// getting the rows facets
					final String[] rows = new String[recRows.length];
					for (int i = 0; i< recRows.length; i++) {
						rowFacets = rowFacets+recRows[i].getAttributeAsString("nameDimension")+",";
						rows[i] = recRows[i].getAttributeAsString("idDimension");
					}
					// getting the facets IDs and Titles
					facetInfo = new String[columns.length+rows.length+1][2];// add an extra dimension to the scenarios
					Criteria criteria = new Criteria();
					criteria.addCriteria("nameCube", selectCubes.getValueAsString());
					criteria.addCriteria("rowFacets", rowFacets);
					criteria.addCriteria("columnFacets", columnFacets);
					final ListGrid grid = new ListGrid();
					grid.setDataSource(dsMembers);
					grid.fetchData(criteria, new DSCallback(){
						@Override
						public void execute(DSResponse response, Object rawData, DSRequest request) {
							ListGridRecord rec[] = grid.getRecords();
							// getting facets for columns
							boolean facetExist = false;
							contFacet = 0;
							int cont = 0;
							for (int i = 0; i < recColumns.length; i++) {
								FacetValue[] values = new FacetValue[rec.length];
								cont = 0;
								for (int j = 0; j < rec.length; j++) {
									if (recColumns[i].getAttributeAsString("idDimension").equalsIgnoreCase(rec[j].getAttributeAsString("idDimension"))) {
										if (!facetExist) {
											facets[contFacet] = new Facet();
											facets[contFacet].setId(recColumns[i].getAttributeAsString("idDimension"));
											facets[contFacet].setTitle(recColumns[i].getAttributeAsString("nameDimension"));  
											facets[contFacet].setCanCollapse(true);
											facets[contFacet].setIsTree(true);
											facetInfo[contFacet][0] = recColumns[i].getAttributeAsString("idDimension");
											facetInfo[contFacet][1] = recColumns[i].getAttributeAsString("nameDimension");
											facetExist = true;
										}
										values[cont] = new FacetValue(rec[j].getAttributeAsString("idMember"),
											rec[j].getAttributeAsString("nameMember"),
											rec[j].getAttributeAsString("idParent"));
										values[cont].setCollapsed(rec[j].getAttributeAsBoolean("collapsed")); 
										cont = cont + 1;
									}// close the if block
								}// close the j block
								FacetValue[] valuesAux = new FacetValue[cont];
	   							int cont1 = 0;
	   							for (int j = 0; j < values.length; j++) {
	   							    if (values[j] != null) {
	   									valuesAux[cont1] = values[j];
	   									cont1++;
	   							    }
	   							}
	   							facets[contFacet].setValues(valuesAux);
								contFacet = contFacet + 1;
								facetExist = false;
							}// close the i block
							// getting facets for rows
							facetExist = false;
							cont = 0;
							for (int i = 0; i < recRows.length; i++) {
								FacetValue[] values = new FacetValue[rec.length];
								cont = 0;
								for (int j = 0; j < rec.length; j++) {
									if (recRows[i].getAttributeAsString("idDimension").equalsIgnoreCase(rec[j].getAttributeAsString("idDimension"))) {
										if (!facetExist) {
											facets[contFacet] = new Facet();
											facets[contFacet].setId(recRows[i].getAttributeAsString("idDimension"));
											facets[contFacet].setTitle(recRows[i].getAttributeAsString("nameDimension"));  
											facets[contFacet].setCanCollapse(true);
											facets[contFacet].setIsTree(true);
											facetInfo[contFacet][0] = recRows[i].getAttributeAsString("idDimension");
											facetInfo[contFacet][1] = recRows[i].getAttributeAsString("nameDimension");
											facetExist = true;
										}
										values[cont] = new FacetValue(rec[j].getAttributeAsString("idMember"),
											rec[j].getAttributeAsString("nameMember"),
											rec[j].getAttributeAsString("idParent"));
										values[cont].setCollapsed(rec[j].getAttributeAsBoolean("collapsed"));
										cont = cont + 1;
									}// close the if block
								}// close the j block
								FacetValue[] valuesAux = new FacetValue[cont];
	   							int cont1 = 0;
	   							for (int j = 0; j < values.length; j++) {
	   							    if (values[j] != null) {
	   									valuesAux[cont1] = values[j];
	   									cont1++;
	   							    }
	   							}
								facets[contFacet].setValues(valuesAux);
								contFacet = contFacet + 1;
								facetExist = false;
							}// close the i block	
							// create the Scenario facet
							facets[contFacet] = new Facet();
							facets[contFacet].setId("Scenarios");
							facets[contFacet].setTitle("Scenarios");  
							facets[contFacet].setValues(new FacetValue(selectCubes.getValueAsString(), selectCubes.getValueAsString()));
							facetInfo[contFacet][0] = "Scenarios";
							facetInfo[contFacet][1] = "Scenarios";
							// create the cubeGrid
							createAdvancedCube();
							// setting rows and columns for the cubeGrid
					        advancedCube.setRowFacets(rows);  
					        advancedCube.setColumnFacets(columns);
					        advancedCube.setFacets(facets);
					        
					        FacetValueMap fixedFacetValues = new FacetValueMap();  
					        fixedFacetValues.addMapping("Scenarios", selectCubes.getValueAsString());  
					        advancedCube.setFixedFacetValues(fixedFacetValues); 
					        Criteria criteria = new Criteria();
							criteria.addCriteria("rowFacets", rowFacets);
							criteria.addCriteria("columnFacets", columnFacets);
							advancedCube.setCriteria(criteria);
							
					        // prepare the facets control
					        controlCanvas = getFacetControls();
					        
					        rightLayout.destroy();
					        rightLayout = new VLayout();  
					        rightLayout.setWidth(500);  
					        rightLayout.setHeight100();  
					        rightLayout.setMembersMargin(8);  
					        rightLayout.setLayoutMargin(10);
					        rightLayout.addMember(controlCanvas);
					        rightLayout.addMember(reportLabel);
					        rightLayout.addMember(advancedCube);
					        mainLayout.addMember(rightLayout);
					        
					        updateLists();
				            updateLabels();
						}// close execute block
					});
				}
	    	 });
	    	 form.setFields(selectCubes);
	    	 
	    	 leftLayout.setMembers(form, gridDimensions, gridRows, gridColumns, buttonCreateCube);
	    	 mainLayout.addMember(leftLayout);
	    	 mainLayout.addMember(rightLayout);
	         topCanvas = mainLayout;
             
	     } else {  
	         HTMLFlow htmlFlow = new HTMLFlow("<div class='explorerCheckErrorMessage'><p>This example is disabled in this SDK because it requires the optional " +  
	            "<a href=\"http://www.smartclient.com/product/index.jsp\" target=\"_blank\">Analytics module</a>.</p>" +  
	            "<p>Click <a href=\"http://www.smartclient.com/smartgwtee/showcase/#cube-analytics\" target=\"\">here</a> to see this example on smartclient.com</p></div>");  
	         htmlFlow.setWidth100();  
	        topCanvas = htmlFlow;  
	     }  
	     topCanvas.draw();  
	 }  
	      
	    private void createAdvancedCube() {  

	    	// define the cubegrid
	        advancedCube = new CubeGrid();
	        advancedCube.setAutoFetchData(true);
	        
	        //in order to enable charting, the Drawing module must be present  
	        if(SC.hasDrawing()) {  
	            advancedCube.setEnableCharting(true);  
	        }  
	      
	        final DataSource ds = DataSource.get("listData");
	        advancedCube.setDataSource(ds);
	        advancedCube.setWidth(700);
	        advancedCube.setValueProperty("value");  
	        advancedCube.setCellIdProperty("cellID");  
	        advancedCube.setCanHover(true);  
	        advancedCube.setShowCellContextMenus(true);  
	        advancedCube.setCellFormatter(new CellFormatter(){

				@Override
				public String format(Object value, ListGridRecord record,
						int rowNum, int colNum) 
				{
					// 
					if(value == null) return null;  
		            try {  
		                return nf.format(Float.parseFloat((String.valueOf(value))));  
		            } catch (Exception e) {
		                return value.toString();  
		            }   
				}
	           });
	        advancedCube.setHoverCustomizer(new HoverCustomizer() {  
	            @Override  
	            public String hoverHTML(Object value, ListGridRecord record, int rowNum,  
	                                       int colNum) 
	            {  
	                if (record != null) {  
	                    return "cell value: " + record.getAttribute("value")  
	                         + "<br>cell ID: " + record.getAttribute("cellID");  
	                }  
	                return null;  
	            }  
	        });
	      
	        advancedCube.setHoverHeight(20);  
	        advancedCube.setHoverWidth(150);
	        advancedCube.setValueTitle("Sales");
	        advancedCube.setCanCollapseFacets(true);  
	        advancedCube.setCanMinimizeFacets(true);  
	        advancedCube.setAutoSelectValues(AutoSelectionModel.BOTH);  
	        advancedCube.setRowHeaderGridMode(true);  
	        advancedCube.setCanMoveFacets(true);  
			
	        advancedCube.addFacetAddedHandler(new FacetAddedHandler() {  
	            @Override  
	            public void onFacetAdded(FacetAddedEvent event) {  
	                updateLists();  
	                updateLabels();  
	            }  
	        });  
	  
	        advancedCube.addFacetMovedHandler(new FacetMovedHandler() {  
	            @Override  
	            public void onFacetMoved(FacetMovedEvent event) {  
	                updateLabels();  
	                updateLists();  
	            }  
	        });  
	  
	        advancedCube.addFixedFacetValueChangedHandler(new FixedFacetValueChangedHandler() {  
	            @Override  
	            public void onFixedFacetValueChanged(FixedFacetValueChangedEvent event) {  
	                updateLabels();  
	                updateLists();  
	            }  
	        });
	    }   
	        
	    private Canvas getFacetControls() {  
	        VLayout menuButtonStack = new VLayout();  
	        menuButtonStack.setWidth(175);  
	        menuButtonStack.setMembersMargin(10);  
	  
	        // Create the FacetMenuButtons, and FacetMenus for each facet  
	        for (int i = 0; i < facetInfo.length; i++) {  
	            String facetId = facetInfo[i][0];  
	            String facetTitle = facetInfo[i][1];
	            FacetMenuButton button = new FacetMenuButton(facetId, facetTitle);  
	            FacetMenu menu = new FacetMenu(advancedCube, facetId);  
	            button.setMenu(menu);  
	            menuButtonStack.addMember(button);  
	        }
	  
	        // Create 2 ListGrids as an alternative UI for drag-rearranging facets  
	        rowFacetList = new FacetList(advancedCube, true);  
	        rowFacetList.setFields(new ListGridField("title", "Row Facets"));  
	        rowFacetList.setWidth(150);  
	        rowFacetList.setHeight(150);  
	        rowFacetList.setLeft(250);  
	  
	        colFacetList = new FacetList(advancedCube, false);  
	        colFacetList.setFields(new ListGridField("title", "Column Facets"));  
	        colFacetList.setLeft(450);  
	        colFacetList.setHeight(150);  
	        colFacetList.setWidth(150);
	  
	        // Combine the controls into a single canvas for easy UI management  	  
	        Canvas controlCanvas = new Canvas();  
	        controlCanvas.setWidth(600);  
	        controlCanvas.setHeight(150);  
	        controlCanvas.setOverflow(Overflow.HIDDEN);  
	        controlCanvas.setLayoutAlign(Alignment.CENTER);  
	        controlCanvas.addChild(menuButtonStack);  
	        controlCanvas.addChild(rowFacetList);  
	        controlCanvas.addChild(colFacetList);  
	  
	        return controlCanvas;  
	    }  
	  
	    public void updateLists() {  
	        // Update the data for each ListGrid based on the rowFacets / columnFacets arrays  
	        // for the CubeGrid  
	        RecordList rowFacetData = new RecordList();  
	        String[] rowFacets = advancedCube.getRowFacets();  
	        for (int i = 0; i < rowFacets.length; i++) {  
	            Facet facet = advancedCube.getFacet(rowFacets[i]);  
	            ListGridRecord facetRecord = new ListGridRecord();  
	            facetRecord.setAttribute("id", facet.getId());  
	            facetRecord.setAttribute("title", facet.getTitle());  
	  
	            rowFacetData.add(facetRecord);  
	        }  
	        rowFacetList.setData(rowFacetData);  
	  
	        RecordList colFacetData = new RecordList();  
	        String[] colFacets = advancedCube.getColumnFacets();  
	        for (int i = 0; i < colFacets.length; i++) {  
	            Facet facet = advancedCube.getFacet(colFacets[i]);  
	            ListGridRecord facetRecord = new ListGridRecord();  
	            facetRecord.setAttribute("id", facet.getId());  
	            facetRecord.setAttribute("title", facet.getTitle());  
	  
	            colFacetData.add(facetRecord);  
	        }  
	        colFacetList.setData(colFacetData);  
	  
	    }  
	  
	    public void updateLabels() {  
	        // Fixed facet values  
	        // Update menus and assemble descriptive string  
	        FacetValueMap fixedValues = advancedCube.getFixedFacetValues();  
	        String[] fixedFacets = fixedValues.getAttributes();  
	        String fixedValuesString = "<B>Report - fixed values: ";  
	        if (fixedFacets.length == 0) {  
	            fixedValuesString += "none.</B>";  
	        } else {  
	            for (int i = 0; i < fixedFacets.length; i++) {  
	                String facetId = fixedFacets[i];
	                FacetValue fv = advancedCube.getFacetValue(facetId, fixedValues.getAttribute(facetId));  
	  
	                MenuButton button = (MenuButton) Canvas.getById(facetId + "Button");  
	                button.setTitle("<b>" + facetId + "</b>: [" + fv.getTitle() + "]");  
	                fixedValuesString += (i == 0 ? " " : ", ") + facetId + ": <i>'" + fv.getTitle() + "'</i>";
	            }  
	            fixedValuesString += "</B>";  
	        }  
	        reportLabel.setContents(fixedValuesString);  
	  
	        String[] rowFacets = advancedCube.getRowFacets();  
	        for (int i = 0; i < rowFacets.length; i++) {  
	            Facet facet = advancedCube.getFacet(rowFacets[i]);  
	            MenuButton button = (MenuButton) Canvas.getById(facet.getIdAsString() + "Button");  
	            if (button != null) button.setTitle("<b>" + facet.getTitle() + "</b>: [ in Rows ]");  
	        }  
	  
	        String[] colFacets = advancedCube.getColumnFacets();  
	        for (int i = 0; i < colFacets.length; i++) {  
	            Facet facet = advancedCube.getFacet(colFacets[i]);
	            MenuButton button = (MenuButton) Canvas.getById(facet.getIdAsString() + "Button");  
	            if (button != null) button.setTitle("<b>" + facet.getTitle() + "</b>: [ in Columns ]");  
	        }  
	    }  
}

